/*
 * #%L
 * ToPIA :: Persistence
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2004 - 2012 CodeLutin
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation, either version 3 of the 
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Lesser Public License for more details.
 * 
 * You should have received a copy of the GNU General Lesser Public 
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/lgpl-3.0.html>.
 * #L%
 */
package org.nuiton.topiatest;

import java.util.Collection;
import org.nuiton.topia.persistence.TopiaEntity;

public interface Company extends TopiaEntity {

    String PROPERTY_NAME = "name";

    String PROPERTY_SIRET = "siret";

    String PROPERTY_EMPLOYE = "employe";

    String PROPERTY_STORE_BILL = "storeBill";

    String PROPERTY_DEPARTMENT = "department";

    void setName(String name);

    String getName();

    void setSiret(int siret);

    int getSiret();

    void addEmploye(Employe employe);

    void addAllEmploye(Collection<Employe> employe);

    void setEmploye(Collection<Employe> employe);

    void removeEmploye(Employe employe);

    void clearEmploye();

    Collection<Employe> getEmploye();

    Employe getEmployeByTopiaId(String topiaId);

    int sizeEmploye();

    boolean isEmployeEmpty();

    void addStoreBill(Bill storeBill);

    void addAllStoreBill(Collection<Bill> storeBill);

    void setStoreBill(Collection<Bill> storeBill);

    void removeStoreBill(Bill storeBill);

    void clearStoreBill();

    Collection<Bill> getStoreBill();

    Bill getStoreBillByTopiaId(String topiaId);

    Bill getStoreBill(Store store);

    int sizeStoreBill();

    boolean isStoreBillEmpty();

    void addDepartment(Department department);

    void addAllDepartment(Collection<Department> department);

    void setDepartment(Collection<Department> department);

    void removeDepartment(Department department);

    void clearDepartment();

    Collection<Department> getDepartment();

    Department getDepartmentByTopiaId(String topiaId);

    int sizeDepartment();

    boolean isDepartmentEmpty();

} //Company
